<?php
/* $Id: calendar.php 40 2009-10-23 22:54:38Z mir $ */
require_once 'config.inc.php';
require_once 'user_validate.php';

valid_user();

if (! defined($_SESSION['__ROOT__']) && empty($_SESSION['__ROOT__'])) {
    if (session_id())
        session_destroy();
    header('Location: ' . WEB_ROOT . 'error.html');
    exit;
}

require_once 'persistens.php';
//var_dump($_POST);
//exit();
include TOP_FOLDER.'/include/header.inc.php';
include TOP_FOLDER.'/include/menu.inc.php';

function colors($selected = null) {
    $list = array('aqua', 'black', 'blue', 'fuchsia', 'gray', 'green',
        'lime', 'maroon', 'navy', 'olive', 'purple', 'red', 'silver',
        'teal', 'white', 'yellow');

    $colors = '';
    foreach ($list as $color) {
        $colors .= "<option value=\"$color\" style=\"background: $color\"";
        if ($selected && $selected == $color)
            $colors .= ' selected="true"';
        $colors .= ">$color</option>";
    }
    return $colors;
}

$user = $_SESSION['user_settings'];
if (count($_POST) > 0 && isset($_POST['action'])) {
    $db = Persistens::getInstance(DBDRIVER);
    $calconf = $_POST['calendar'];
    if ($_POST['action'] == 'new') {
        $row = $calconf;
        $text = "url={$row['url']}\nuid={$row['uid']}\npwd={$row['pwd']}";
        $text = encode($text);
        $calendar = new CalendarInfo();
        $calendar->name = $row['name'];
        $calendar->color = $row['color'];
        $calendar->config = $text;
        $id = $db->addCalendar($user->getUid(), $calendar);
        if (is_numeric($id)) {
            $user->addCalendar($id, $calendar);
            $pageView = "<p class=\"usermanage\">Calendar was added with id $id</p>";
        }
        else {
            $pageView = "<p class=\"usermanage\">$id</p>";
        }
    }
    else {
        foreach ($calconf as $id => $row) {
            if (! isset($row[check]))
                continue;
            if ($_POST['action'] == 'update') {
                $text = "url={$row['url']}\nuid={$row['uid']}\npwd={$row['pwd']}";
                $text = encode($text);
                $calendar = new CalendarInfo();
                $calendar->name = $row['name'];
                $calendar->color = $row['color'];
                $calendar->config = $text;
                $res = $db->updateCalendar($user->getUid(), $id, $calendar);
                if ($res === TRUE) {
                    $user->addCalendar($id, $calendar);
                    $pageView = "<p class=\"usermanage\">Calendar with id $id was updated</p>";
                }
                else {
                    $pageView = "<p class=\"usermanage\">$id</p>";
                }
            }
            else {
                $res = $db->deleteCalendar($user->getUid(), $id);
                if ($res === TRUE) {
                    $user->removeCalendar($id);
                    $pageView = "<p class=\"usermanage\">Calendar with id $id was removed</p>";
                }
                else {
                    $pageView = "<p class=\"usermanage\">$id</p>";
                }
            }
        }
    }
    $pageView .= '</table>';
}
else if (count($_POST) > 0 && isset($_POST['new'])) {
    $colors = colors();
    $pageView = '<form id="form" action="'.$_SERVER[PHP_SELF].'" method="post">
                 <table class="config">';
    $pageView .= "<tr><td>Name</td>
                <td><input name=\"calendar[name]\" type=\"text\" size=\"20\"/></td>
                </tr>
                <tr>
                <td>Color</td>
                <td>
                    <select name=\"calendar[color]\">
                       $colors
                    </select>
                </td>
                </tr>
                <tr>
                <td>URL</td>
                <td><input name=\"calendar[url]\" type=\"text\" size=\"50\"/></td>
                </tr>
                <tr>
                <td>Username</td>
                <td><input name=\"calendar[uid]\" type=\"text\" size=\"20\"/></td>
                </tr>
                <tr>
                <td>Password</td>
                <td><input name=\"calendar[pwd]\" type=\"password\" size=\"20\"/></td>
                </tr>";
    $pageView .= '<tr>
                    <td colspan="6" style="text-align: center">
                        <input type="button" value="Submit"
                        onclick="document.getElementById(\'form\').submit()">
                        <input type="hidden" name="action" value="new"/>
                    </td>
                </tr>';
    $pageView .= '</table></form>';
}
else {
    //var_dump($_SESSION['authenticate']);
    //var_dump($user);
    //exit();
    $calendars = $user->getCalendars();
    //var_dump($calendars);
    //exit();
    $pageView = '<form id="form" action="'.$_SERVER[PHP_SELF].'" method="post">
                 <table id="cal">';

    if (count($calendars) > 0) {
        foreach ($calendars as $id => $cal) {
            $text = decode($cal->config);
            $color = colors($cal->color);
            $info = implode_cal($text);
            $pageView .= "<tr><td>Name</td>
                <td><input name=\"calendar[$id][name]\" type=\"text\" size=\"8\" value=\"{$cal->name}\"/></td>
                <td>Color</td>
                <td>
                    <select name=\"calendar[$id][color]\">
                        $color
                    </select>
                </td>
                <td>URL</td>
                <td><input name=\"calendar[$id][url]\" type=\"text\" size=\"40\" value=\"{$info['url']}\"/>
                </td>
                <td>Username</td>
                <td><input name=\"calendar[$id][uid]\" type=\"text\" size=\"8\" value=\"{$info['uid']}\"/></td>
                <td>Password</td>
                <td><input name=\"calendar[$id][pwd]\" type=\"password\" size=\"8\" value=\"{$info['pwd']}\"/></td>
                <td><input type=\"checkbox\" name=\"calendar[$id][check]\" value=\"$id\"/></td>
                </tr>";
        }
        $pageView .= '<tr>
                        <td colspan="11" style="text-align: center">
                            <input type="radio" name="action" value="delete">Delete</input>
                            <input type="radio" name="action" value="update">Update</input>
                        </td>
                    </tr>
                    <tr>
                        <td colspan="11" style="text-align: center">
                            <input type="button" value="Submit"
                            onclick="document.getElementById(\'form\').submit()">
                            <input type="submit" name="new" value="New Calendar"/>
                        </td>
                    </tr>';
    }
    else {
        $pageView .= '<tr>
                            <td>
                                <input type="submit" name="new" value="New Calendar"/>
                            </td>
                      </tr>';
    }
    $pageView .= '</table></form>';
}
print "<div id=\"ui\">$pageView</div>";

include TOP_FOLDER.'/include/footer.inc.php';
?>
