BEGIN TRANSACTION;
DELETE FROM sqlite_sequence;
INSERT INTO "sqlite_sequence" VALUES('roles',2);
INSERT INTO "sqlite_sequence" VALUES('user',5);
CREATE TABLE roles (
id integer primary key autoincrement,
name text not null
);
INSERT INTO "roles" VALUES(0,'administrator');
INSERT INTO "roles" VALUES(1,'power user');
INSERT INTO "roles" VALUES(2,'user');
CREATE TABLE user (
id integer primary key autoincrement,
uid text not null,
pwd text not null,
userrole integer not null,
timeout integer default 3600,
userview text default 'week',
weekstart integer default 0,
daystart real default 8.00,
dayend real default 17.00,
seckey text default '',
pubkey text default '',
constraint uid_index unique (uid)
constraint userrole_fk foreign key (userrole) references roles (id)
on delete restrict
on update cascade
on insert cascade
);
INSERT INTO "user" VALUES(1,'admin','d033e22ae348aeb5660fc2140aec35850c4da997',0,1200,'week',0,8.0,17.0,'','');
INSERT INTO "user" VALUES(2,'test','a94a8fe5ccb19ba61c4c0873d391e987982fbbd3',1,3600,'week',0,8.0,17.0,'da830961dc3af47fff6d1af3be3d66d6','yQ腧dga8(
<ky*:');
CREATE TABLE calendar (
id integer default -1,
uid integer not null,
name text not null,
color text default 'navy',
config text default '',
constraint calendar_pk primary key (id, uid),
constraint uid_fk foreign key (uid) references user (id)
on delete cascade
on update cascade
on insert cascade
);
CREATE TRIGGER compute_id after insert on calendar
begin
    update calendar set id = (select max(id) + 1 from calendar) where id = -1;
end;
CREATE TRIGGER genfkey2_insert_referencing BEFORE INSERT ON "calendar" WHEN 
    new."uid" IS NOT NULL AND NOT EXISTS (SELECT 1 FROM "user" WHERE new."uid" == "id")
BEGIN
  SELECT RAISE(ABORT, 'constraint failed');
END;
CREATE TRIGGER genfkey2_update_referencing BEFORE
    UPDATE OF uid ON "calendar" WHEN 
    new."uid" IS NOT NULL AND 
    NOT EXISTS (SELECT 1 FROM "user" WHERE new."uid" == "id")
BEGIN
  SELECT RAISE(ABORT, 'constraint failed');
END;
CREATE TRIGGER genfkey2_delete_referenced BEFORE DELETE ON "user" WHEN
    EXISTS (SELECT 1 FROM "calendar" WHERE old."id" == "uid")
BEGIN
  DELETE FROM "calendar" WHERE "uid" = old."id";
END;
CREATE TRIGGER genfkey2_update_referenced AFTER
    UPDATE OF id ON "user" WHEN 
    EXISTS (SELECT 1 FROM "calendar" WHERE old."id" == "uid")
BEGIN
  UPDATE "calendar" SET "uid" = new."id" WHERE "uid" = old."id";
END;
CREATE TRIGGER genfkey1_insert_referencing BEFORE INSERT ON "user" WHEN 
    new."userrole" IS NOT NULL AND NOT EXISTS (SELECT 1 FROM "roles" WHERE new."userrole" == "id")
BEGIN
  SELECT RAISE(ABORT, 'constraint failed');
END;
CREATE TRIGGER genfkey1_update_referencing BEFORE
    UPDATE OF userrole ON "user" WHEN 
    new."userrole" IS NOT NULL AND 
    NOT EXISTS (SELECT 1 FROM "roles" WHERE new."userrole" == "id")
BEGIN
  SELECT RAISE(ABORT, 'constraint failed');
END;
CREATE TRIGGER genfkey1_delete_referenced BEFORE DELETE ON "roles" WHEN
    EXISTS (SELECT 1 FROM "user" WHERE old."id" == "userrole")
BEGIN
  SELECT RAISE(ABORT, 'constraint failed');
END;
CREATE TRIGGER genfkey1_update_referenced AFTER
    UPDATE OF id ON "roles" WHEN 
    EXISTS (SELECT 1 FROM "user" WHERE old."id" == "userrole")
BEGIN
  UPDATE "user" SET "userrole" = new."id" WHERE "userrole" = old."id";
END;
COMMIT;
